=== debian/changelog ===
vulkan-validationlayers (1.3.204.1-2) unstable; urgency=medium

  * rules: Fix location of spirv-headers.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 07 Apr 2022 13:54:10 +0300

vulkan-validationlayers (1.3.204.1-1) unstable; urgency=medium

  * New upstream release.
  * fix-build.diff: Dropped, upstream.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 15 Mar 2022 11:57:37 +0200

vulkan-validationlayers (1.3.204.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-depends.
  * patches: Refreshed.
  * fix-build.diff: Fix a build regression.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 16 Feb 2022 18:42:31 +0200

vulkan-validationlayers (1.2.198.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dependency.
  * fix-mips-ftbfs.diff: Fix build on mips*. (Closes: #998294)
  * control: Bump spirv-headers, -tools build-deps.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 07 Jan 2022 13:55:58 +0200
