## vulkan-validationlayers 1.3.224.0

=== debian/changelog ===
vulkan-validationlayers (1.3.224.0-1) unstable; urgency=medium

  * New upstream release.
  * patches: Refreshed.
  * control: Bump build-deps of glslang-dev, libvulkan-dev and spirv-
    tools.
  * rules: Don't specify the vulkan headers dir, the build can find it
    now.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 25 Aug 2022 19:35:59 +0300

vulkan-validationlayers (1.3.216.0-1) unstable; urgency=medium

  * New upstream release. (Closes: #1013529)
  * control: Bump libvulkan-dev build-dep.
  * control: Bump build-depends for glslang-dev, spirv-headers and spirv-
    tools.
  * fix-mips-ftbfs.diff: Dropped, not needed anymore.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 04 Jul 2022 12:52:08 +0300
