=== debian/control ===
--- 
+++ 
@@ -4,15 +4,15 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 12),
  cmake,
- glslang-dev (>= 11.8.0+1.3.204.0),
- libvulkan-dev (>= 1.3.204.0),
+ glslang-dev (>= 11.11.0),
+ libvulkan-dev (>= 1.3.224),
  libwayland-dev,
  libx11-dev,
  libxrandr-dev,
  pkg-config,
  python3,
- spirv-headers (>= 1.5.5),
- spirv-tools (>= 2022.1+1.3.204.0-2),
+ spirv-headers (>= 1.6.1+1.3.216.0),
+ spirv-tools (>= 2022.3),
 Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-ValidationLayers
